<template>
  <section class="selector_container" :style="this.style">
    <b class="caption">{{ caption }}</b>
    <select class="selector" v-model="selectedOption">
      <option
        v-for="option in options"
        v-bind:value="option.value"
        v-bind:key="option.value"
      >
        {{ option.text }}
      </option>
    </select>
  </section>
</template>

<script>
export default {
  name: "OptionSelector",
  props: ["options", "initialOption", "caption", "style"],
  data() {
    return {
      selectedOption: this.initialOption,
    };
  },
  emits: ["selected"],
  methods: {
    emitSelected(val) {
      this.$emit("selected", val);
    },
  },
  watch: {
    selectedOption(val) {
      this.emitSelected(val);
    },
  },
};
</script>

<style scoped></style>
